
Foreman - Bug #5213

Error during delete a puppet class

04/16/2014 03:38 PM - Olivier Cruilles

Status: Duplicate   

Priority: Normal   

Assignee:    

Category: Database   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Hello,

We use the Foreman version 1.4.2 and we have an error every time we want to delete a puppet class in the Class Menu.

This is the full trace of this problem

Thank you in advance.

ActiveRecord::StatementInvalid

Mysql2::Error: Cannot delete or update a parent row: a foreign key constraint fails (`puppet`.`environment_classes`, CONSTRAINT

`environment_classes_puppetclass_id_fk` FOREIGN KEY (`puppetclass_id`) REFERENCES `puppetclasses` (`id`)): DELETE FROM

`puppetclasses` WHERE `puppetclasses`.`id` = 452

app/controllers/puppetclasses_controller.rb:42:in `destroy'

app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

lib/middleware/catch_json_parse_errors.rb:9:in `call'

Message in the log:

Started DELETE "/puppetclasses/alloybox::service" for 10.100.21.48 at 2014-04-16 11:29:45 0400

Processing by PuppetclassesController#destroy as HTML

Parameters: {"authenticity_token"=>"B4umlbOcySr7JxDvHIAhRDB9FNuLZpzT9NdnZ2I8Lo8=", "id"=>"alloybox::service"}

User Load (0.2ms)  SELECT `users`.* FROM `users` WHERE `users`.`id` = 2 LIMIT 1

Setting current user thread-local variable to ocruilles

(0.1ms)  SELECT COUNT() FROM `taxonomies` WHERE `taxonomies`.`type` IN ('Organization')

Setting current organization thread-local variable to none

(0.1ms)  SELECT COUNT() FROM `taxonomies` WHERE `taxonomies`.`type` IN ('Location')

Setting current location thread-local variable to none

(0.1ms)  SELECT id FROM `taxonomies` WHERE `taxonomies`.`type` IN ('Location') LIMIT 1

(0.1ms)  SELECT id FROM `taxonomies` WHERE `taxonomies`.`type` IN ('Organization') LIMIT 1

Puppetclass Load (0.1ms)  SELECT `puppetclasses`.* FROM `puppetclasses` WHERE `puppetclasses`.`name` = 'alloybox::service'

ORDER BY puppetclasses.name LIMIT 1

EnvironmentClass Load (0.1ms)  SELECT `environment_classes`.* FROM `environment_classes` WHERE

`environment_classes`.`puppetclass_id` IN (452) AND (environment_classes.lookup_key_id is NOT NULL)

(0.1ms)  BEGIN

Host::Managed Load (0.3ms)  SELECT `hosts`.* FROM `hosts` INNER JOIN `host_classes` ON `hosts`.`id` =

`host_classes`.`host_id` WHERE `hosts`.`type` IN ('Host::Managed') AND `host_classes`.`puppetclass_id` = 452

Hostgroup Load (0.2ms)  SELECT `hostgroups`.* FROM `hostgroups` INNER JOIN `hostgroup_classes` ON `hostgroups`.`id` =

`hostgroup_classes`.`hostgroup_id` WHERE `hostgroup_classes`.`puppetclass_id` = 452 ORDER BY hostgroups.label

HostgroupClass Load (0.1ms)  SELECT `hostgroup_classes`.* FROM `hostgroup_classes` WHERE

`hostgroup_classes`.`puppetclass_id` = 452

HostClass Load (0.1ms)  SELECT `host_classes`.* FROM `host_classes` WHERE `host_classes`.`puppetclass_id` = 452

LookupKey Load (0.1ms)  SELECT `lookup_keys`.* FROM `lookup_keys` WHERE `lookup_keys`.`puppetclass_id` = 452 ORDER

BY lookup_keys.key

Puppetclass Load (0.1ms)  SELECT `puppetclasses`.* FROM `puppetclasses` WHERE `puppetclasses`.`id` = 452 ORDER BY

puppetclasses.name LIMIT 1

(0.3ms)  SELECT MAX AS max_id FROM `audits` WHERE `audits`.`auditable_id` = 452 AND `audits`.`auditable_type` =

'Puppetclass'

SQL (0.3ms)  INSERT INTO `audits` (`action`, `associated_id`, `associated_name`, `associated_type`, `auditable_id`,
`auditable_name`, `auditable_type`, `audited_changes`, `comment`, `created_at`, `remote_address`, `user_id`, `user_type`,

`username`, `version`) VALUES ('destroy', NULL, NULL, NULL, 452, 'alloybox::service', 'Puppetclass', '--\nname: alloybox::service\n',

NULL, '2014-04-16 15:29:45', '10.100.21.48', NULL, NULL, 'Olivier Cruilles', 2)

Operatingsystem Load (0.1ms)  SELECT `operatingsystems`.* FROM `operatingsystems` INNER JOIN

`operatingsystems_puppetclasses` ON `operatingsystems`.`id` = `operatingsystems_puppetclasses`.`operatingsystem_id` WHERE

`operatingsystems_puppetclasses`.`puppetclass_id` = 452 ORDER BY operatingsystems.name

SQL (0.5ms)  DELETE FROM `puppetclasses` WHERE `puppetclasses`.`id` = 452

Mysql2::Error: Cannot delete or update a parent row: a foreign key constraint fails (`puppet`.`environment_classes`, CONSTRAINT

`environment_classes_puppetclass_id_fk` FOREIGN KEY (`puppetclass_id`) REFERENCES `puppetclasses` (`id`)): DELETE FROM

`puppetclasses` WHERE `puppetclasses`.`id` = 452

(0.7ms)  ROLLBACK

Operation FAILED: Mysql2::Error: Cannot delete or update a parent row: a foreign key constraint fails

(`puppet`.`environment_classes`, CONSTRAINT `environment_classes_puppetclass_id_fk` FOREIGN KEY (`puppetclass_id`)

REFERENCES `puppetclasses` (`id`)): DELETE FROM `puppetclasses` WHERE `puppetclasses`.`id` = 452

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `query'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `block in execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:280:in

`block in log'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_adapter.rb:275:in `log'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract_mysql_adapter.rb:245:i

n `execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/mysql2_adapter.rb:211:in

`execute'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/mysql2_adapter.rb:238:in

`exec_delete'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb

:101:in `delete'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/query_cache.rb:14:in

`delete'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/relation.rb:413:in `delete_all'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/persistence.rb:141:in `destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/locking/optimistic.rb:103:in `destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:254:in `block in destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:480:in

`_run__552166397164050537__destroy__4290636945544318599__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405:in `__run_callback'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385:in `_run_destroy_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:in `run_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/callbacks.rb:254:in `destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:236:in `block in destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:295:in `block in

with_transaction_returning_status'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/database_statements.rb

:192:in `transaction'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:208:in `transaction'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:293:in

`with_transaction_returning_status'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/transactions.rb:236:in `destroy'

/usr/share/foreman/app/controllers/puppetclasses_controller.rb:42:in `destroy'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/implicit_render.rb:4:in `send_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/abstract_controller/base.rb:167:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/rendering.rb:10:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/abstract_controller/callbacks.rb:18:in `block in process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:538:in `block (3 levels) in run

_3808605225920343536__process_action__3709266668007440268__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:215:in `block in 

conditional_callback_around_5386'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:326:in `around'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:310:in `_callback_around_1249'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:214:in

`_conditional_callback_around_5386'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:526:in `block (2 levels) in _run

_3808605225920343536__process_action__3709266668007440268__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:215:in `block in 
conditional_callback_around_5385'

/usr/share/foreman/app/models/concerns/foreman/thread_session.rb:33:in `clear_thread'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:214:in

`_conditional_callback_around_5385'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:415:in `block in _run

_3808605225920343536__process_action__3709266668007440268__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:215:in `block in 

conditional_callback_around_5384'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:326:in `around'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:310:in `_callback_around_13'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:214:in

`_conditional_callback_around_5384'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:414:in `_run

_3808605225920343536__process_action__3709266668007440268__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405:in `__run_callback'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385:in `_run_process_action_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:in `run_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/abstract_controller/callbacks.rb:17:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/rescue.rb:29:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/instrumentation.rb:30:in `block in

process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications.rb:123:in `block in instrument'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/notifications.rb:123:in `instrument'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/instrumentation.rb:29:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/params_wrapper.rb:207:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/railties/controller_runtime.rb:18:in `process_action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/abstract_controller/base.rb:121:in `process'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/abstract_controller/rendering.rb:45:in `process'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal.rb:203:in `dispatch'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal/rack_delegation.rb:14:in `dispatch'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_controller/metal.rb:246:in `block in action'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/routing/route_set.rb:73:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/routing/route_set.rb:73:in `dispatch'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/routing/route_set.rb:36:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/journey-1.0.4/lib/journey/router.rb:68:in `block in call'

/opt/rh/ruby193/root/usr/share/gems/gems/journey-1.0.4/lib/journey/router.rb:56:in `each'

/opt/rh/ruby193/root/usr/share/gems/gems/journey-1.0.4/lib/journey/router.rb:56:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/routing/route_set.rb:600:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/apipie-rails-0.0.23/lib/apipie/static_dispatcher.rb:56:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/best_standards_support.rb:17:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/etag.rb:23:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/conditionalget.rb:35:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/head.rb:14:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/params_parser.rb:21:in `call'

/usr/share/foreman/lib/middleware/catch_json_parse_errors.rb:9:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/flash.rb:242:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/session/abstract/id.rb:205:in `context'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/session/abstract/id.rb:200:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/cookies.rb:339:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/query_cache.rb:64:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/connection_adapters/abstract/connection_pool.rb:473:

in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/callbacks.rb:28:in `block in call'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405:in

`_run__1206601701773069508__call__4290636945544318599__callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:405:in `__run_callback'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:385:in `_run_call_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/callbacks.rb:81:in `run_callbacks'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/callbacks.rb:27:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/remote_ip.rb:31:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/debug_exceptions.rb:16:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/show_exceptions.rb:56:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/rack/logger.rb:26:in `call_app'

/opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/rack/logger.rb:16:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/quiet_assets-1.0.2/lib/quiet_assets.rb:18:in `call_with_quiet_assets'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/request_id.rb:22:in `call'

05/11/2024 3/4



/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/methodoverride.rb:21:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/runtime.rb:17:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/activesupport-3.2.8/lib/active_support/cache/strategy/local_cache.rb:72:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/lock.rb:15:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/actionpack-3.2.8/lib/action_dispatch/middleware/static.rb:62:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-cache-1.2/lib/rack/cache/context.rb:136:in `forward'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-cache-1.2/lib/rack/cache/context.rb:143:in `pass'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-cache-1.2/lib/rack/cache/context.rb:155:in `invalidate'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-cache-1.2/lib/rack/cache/context.rb:71:in `call!'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-cache-1.2/lib/rack/cache/context.rb:51:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/engine.rb:479:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/application.rb:223:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/railties-3.2.8/lib/rails/railtie/configurable.rb:30:in `method_missing'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/builder.rb:134:in `call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/urlmap.rb:64:in `block in call'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/urlmap.rb:49:in `each'

/opt/rh/ruby193/root/usr/share/gems/gems/rack-1.4.1/lib/rack/urlmap.rb:49:in `call'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/lib/phusion_passenger/rack/thread_handler_extension.rb:77:in `process_request'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/lib/phusion_passenger/request_handler/thread_handler.rb:140:in

`accept_and_process_next_request'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/lib/phusion_passenger/request_handler/thread_handler.rb:108:in `main_loop'

/usr/lib/ruby/gems/1.8/gems/passenger-4.0.5/lib/phusion_passenger/request_handler.rb:441:in `block (3 levels) in start_threads'

Rendered common/500.html.erb within layouts/application (75.7ms)

Rendered layouts/base.html.erb (1.1ms)

Completed 500 Internal Server Error in 187ms (Views: 78.2ms | ActiveRecord: 4.2ms)

Olivier

Related issues:

Is duplicate of Foreman - Bug #4379: Foreign key constraint error on deleting... Resolved 02/18/2014

History

#1 - 04/22/2014 09:11 AM - Dominic Cleal

- Is duplicate of Bug #4379: Foreign key constraint error on deleting a class added

#2 - 04/22/2014 09:11 AM - Dominic Cleal

- Project changed from Hammer CLI to Foreman

- Category set to Database

- Status changed from New to Duplicate

Thanks for the report, this appears to be issue #4379.
